package drew.figure;

import java.awt.*;
import math.*;


public class Square extends Figure implements java.io.Serializable
{
  static final long serialVersionUID = -2154227665229871751L;

  double x, y, w, h;

  Vec originVec = new Vec(2);
  Vec sizeVec = new Vec(2);

  public Vec getOriginVec() { return originVec; }
  public void setOriginVec(Vec v)
  {
    this.originVec = v;
    x = v.ref(0);
    y = v.ref(1);
  }



  public Vec getSizeVec() { return sizeVec; }
  public void setSizeVec(Vec v)
  {
    this.sizeVec = v;
    w = v.ref(0);
    h = v.ref(1);
  }




  public void paint(Graphics g)
  {
    g.setColor(foreground);

    Point p1 = new Point();
    Point p2 = new Point();
    Point p3 = new Point();
    Point p4 = new Point();

    transform(x,y,p1);
    transform(x+w,y,p2);
    transform(x+w,y+h,p3);
    transform(x,y+h,p4);

    g.drawLine(p1.x,p1.y,p2.x,p2.y);
    g.drawLine(p2.x,p2.y,p3.x,p3.y);
    g.drawLine(p3.x,p3.y,p4.x,p4.y);
    g.drawLine(p4.x,p4.y,p1.x,p1.y);
    
  }

}
