package drew;

import java.io.Serializable;

public class Test implements Serializable
{
  static long serialVersionUID = 4043246817339963121L;  

  // Default constructor is called exactly once ever:
  // when the object is created.
  // At deserialization, the constructor is *not* called
  public Test()
  {
    System.out.println("Test default constructor called.");
    testJNI();
  }
    

  // Static initializers are evaluated when the class is loaded;
  // i.e. when HotWire starts up.
  static 
  {
    System.out.println("Test static block executed.");
    System.loadLibrary("test");
  }

  public native void testJNI();


}
