package drew.util;

// I don't grock java.text.NumberFormat

public class Format
{
  
  public static String formatDouble(double x, int numFracDigits)
  {
    //System.out.print(x + " = ");

    double positive = x > 0 ? x : -x;
    int exp;
    if (x == 0) 
      exp = 0;
    else
      exp = (int) (Math.log(positive)/Math.log(10));
    

    if (exp < 0) 
      exp--;

    if ((exp < numFracDigits) && (exp > -numFracDigits))
      exp = 0;

    double y = x / Math.pow(10,exp);

    String ys = Double.toString(y);

    int point = ys.lastIndexOf('.');

    if (point != -1)
      {
	if ((ys.length() - point) > numFracDigits)
	  ys = ys.substring(0,point+numFracDigits+1);
      }
    
    if (exp == 0)
      return ys;
    else
      return ys+"E"+exp;
  }

  public static void main(String[] args)
  {
    System.out.println( Format.formatDouble(-2.0,5));
    System.out.println( Format.formatDouble(1.9,5));
    System.out.println( Format.formatDouble(1.9E10,5));
    System.out.println( Format.formatDouble(1.9E-10,5));
    System.out.println( Format.formatDouble(-1.923E-10,5));
    System.out.println( Format.formatDouble(0.0124,5));
    System.out.println( Format.formatDouble(0.0,5));
    
    try { Thread.sleep(100000); } catch (Exception e) {}
  }

}
